import { INotebookTracker } from '@jupyterlab/notebook';
import { CodeCell } from '@jupyterlab/cells';
import './codemirror-finesse';
const plugin = {
    activate,
    id: 'finesse-syntax-jupyter',
    requires: [INotebookTracker],
    autoStart: true
};
function activate(app, tracker) {
    tracker.widgetAdded.connect(activate_finesse);
}
;
function check_all(sender) {
    sender.widgets.forEach(cell => {
        if (cell instanceof CodeCell && cell.model.mimeType != "text/x-finesse-python") {
            cell.model.mimeType = "text/x-finesse-python";
        }
    });
}
;
function check_cell(sender, cell) {
    if (cell instanceof CodeCell) {
        cell.model.mimeType = "text/x-finesse-python";
    }
}
function activate_finesse(sender, panel) {
    panel.content.activeCellChanged.connect(check_cell);
    // I ain't proud of this, but it's the sanest way I could find to get
    // the syntax highlighting to change on startup without selecting a
    // different cell
    setTimeout(() => { check_all(panel.content); }, 500);
}
;
export default plugin;
